//Create Global Variables
toolId = 500; //Set The Id of the clone tool item
var Domain = "http://mods.productminer.com/minecraft/Cloner/"; //Set Root location for assets
var Cloner;//Set Clone Class Reference
var FirstRun = false;
var CurrentClone;
function newLevel(){
	Cloner.loadClones();//load all saved cloned items
		
	//Define Clone Tool
	ModPE.setItem(toolId,"cake",0,"Clone Tool");
	
	//Set up Invironment
	ModPE.overrideTexture("images/items_opaque.png",Domain+"images/customItems.png");
	Item.addCraftRecipe(toolId, 1, 0, [3, 3, 0]);
	Entity.setCarriedItem(Player.getEntity(),toolId,1,0);
}

function useItem(x,y,z,itemId,blockId,side){
	//Set Private Variables
	var playerId = Player.getEntity();
	var ignoreBlocks = [58,54,245,61,62];
	for(var i=0;i<ignoreBlocks.length;i++) {
		if(blockId==ignoreBlocks[i]){
			return;
		}
	};
	//define Clone Tool functions when Item is used
	if(itemId==toolId){
		
		if(CurrentClone==undefined || CurrentClone == null){
			show("Start Selecting Blocks");
			show("Select blocks for structure",1);
			show("Before clicking the key block make sure to click a sign with the name you want",1);
			CurrentClone = new Cloner(x,y,z);
			CurrentClone.addBlock(x,y,z,blockId);
			return;
		}
		if(blockId == 63){
			CurrentClone.rename(x,y,z);
			return;
		}
		if(CurrentClone.isStarter(x,y,z)){
			show("Clone Saved");
			CurrentClone.build();
			CurrentClone = null;
			return;
		}
		if(CurrentClone.exists(x,y,z)){
			show("Block Removed");
			CurrentClone.removeBlock(x,y,z,blockId);
			return;
		}
		if(CurrentClone.blocks.length()>0){
			show("Block Added");
			CurrentClone.addBlock(x,y,z,blockId);
			return;
		}
		
		return;
	}
	if(Cloner.isCloneItem(itemId)){
		show("Item Duplicated");
		Cloner.duplicate(x,y,z,itemId);
		return;
	}
}

(function(){
	//Create The Cloner Class

	//Private Variables
	cloneId = 501;
	var Clones = {};
	var snapDeg = 90;
	var selectBlock = 254;
	var startBlock = 255;
	
	//Define Blocks
	Block.defineBlock(startBlock,"Selector","stone_slab",0,1,0);
	Block.defineBlock(selectBlock,"Start Clone","stone_slab",0,1,0);
	//Define Block Colors
	Block.setColor(startBlock,[0x00FF00]);//Start Block is Blue
	Block.setColor(selectBlock,[0xFF0000]);//Select Blocks are Red
	
	var Clone = function(x,y,z){
		//Clone Object Constructor;
		this.id = cloneId;
		this.name = "Clone Object "+(cloneId - 500);
		this.starterBlock;
		this.offset = {x:x,y:y,z:z,rotation:getSnappedDegrees((deg2Rad(Entity.getYaw())))};
		this.blocks = {};
		cloneId++;
	}
	
	Clone.prototype.addBlock = function(x,y,z,blockId){
		//Start adding blocks to clonable structure;
		var blockType = selectBlock;
		
		if(this.blocks.length()==0){
			this.starterBlock = pn(x,y,z);
			blockType = startBlock;
		}
		this.blocks[pn(x,y,z)] = {x:x - this.offset.x,y:y - this.offset.y,z:z - this.offset.z,blockId:blockId};
		replaceTile(x,y,z,blockType);
		
	}
	
	Clone.prototype.removeBlock = function(x,y,z,blockId){
		//Remove a block from clonable structure
		var block = this.blocks[pn(x,y,z)];
		replaceTile(x,y,z,block.blockId);
		this.blocks[pn(x,y,z)]= null;
		
	}
	
	Clone.prototype.build = function(){
		//Build the data structure and create Built Item
		Clones[this.id] = {name:this.name,blocks:this.blocks,rotation:this.offset.rotation};
		
		for(var key in this.blocks){
			if(this.blocks[key]!=undefined){
				var block = this.blocks[key];
				replaceTile(block.x+this.offset.x,block.y+this.offset.y,block.z+this.offset.z,block.blockId);
			}
		}
		ModPE.setItem(this.id,"record_far",0,this.name);
		addItemInventory(this.id,1,0);		
		Save("Clones",Clones);
	}
	
	Clone.prototype.isStarter = function(x,y,z){
		return (pn(x,y,z)==this.starterBlock);
	}
	
	Clone.prototype.exists = function(x,y,z){
		var block = this.blocks[pn(x,y,z)];
		return (block == null || block == undefined)?false:true;
	}
	
	Clone.prototype.getName = function(){
		//Return the name of the cloned structure
		return this.name;
	}
	Clone.prototype.rename = function(x,y,z){
		var name = Level.getSignText(x,y,z,0);
		show("Clone Renamed " + name);
		this.name = name;
	}
	//Public Static functions
	Clone.duplicate = function(x,y,z,id){
		var clone = Clones[id];
		var blocks = clone.blocks;
		var rotation = getSnappedDegrees();
		for(var key in blocks){
			if(blocks[key]!='undefined' && typeof blocks[key] != 'function'){
				var block = blocks[key];
				var dist = Math.sqrt((block.x*block.x)+(block.z*block.z));
				var blockrot = Math.atan2(block.x,block.z)-degsToRads(clone.rotation);
				var pos = {};
				pos.x = block.x+x;//Math.cos(blockrot-degsToRads(rotation))*dist;
				//pos.x = x + Math.cos(blockrot - degsToRads(rotation))*dist;
				pos.y = block.y+y+1;
				//pos.z = z + Math.sin(blockrot - degsToRads(rotation))*dist;
				pos.z = block.z+z;//-Math.sin(blockrot-degsToRads(rotation))*dist;
				replaceTile(pos.x,pos.y,pos.z,block.blockId);
			}
		}
	} 
	
	Clone.loadClones = function(){
		var savedClones = Read("Clones");
		if(typeof savedClones == "Object"){
			Clones = savedClones;
		}
	}
	
	Clone.isCloneItem = function(itemId){
		return (Clones[itemId] != undefined);
	}
	Clone.getClones = function(){
		var keys = [];
		for(var k in Clones){
			keys.push(k);
		}
		return keys;
	}
	
	function replaceTile(x,y,z,blockId){
		Level.destroyBlock(x,y,z,false);
		Level.setTile(x,y,z,blockId);
	}
	
	function pn(x,y,z){
		return x+","+y+","+z;
	}
	
	function deg2Rad(deg){
		//convert degrees to radians;
		return deg * Math.PI/180;
	}
	function getSnappedDegrees(snapDegs){
		var snapDegs = (snapDegs==undefined)?90:snapDegs;
		var rot = Math.abs(getYaw() % 360);
		return (Math.round(rot/snapDeg)*snapDeg);
	}
	function degsToRads(degs){
		return degs * (Math.PI/180);
	}
	//Set root reference to the Clone class
	Cloner = Clone;
})();
//Useful Functions
function show(msg,method){
	method = (method==undefined)?0:method;
	switch(method){
		case 0:
			ModPE.showTipMessage(msg);
			break;
		case 1:
			clientMessage(msg);
			break;
		case 2:
			print(msg);
			break;
	}
	
}
function Save(name,data){
	ModPE.saveData(name,data);
}
function Read(name){
	return ModPE.readData(name);
}
function Remove(name){
	ModPe.removeData(name);
}
Object.prototype.length = function () {
	var keys = [],k;
	for (k in this) {
		if (Object.prototype.hasOwnProperty.call(this, k)) {
			if(k!=null)keys.push(1);
		}
	}
	return keys.length;
}